// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// @generated by protoc-gen-es v1.0.0
// @generated from file google/api/expr/v1alpha1/value.proto (package google.api.expr.v1alpha1, syntax proto3)
/* eslint-disable */
// @ts-nocheck

import type { Any, BinaryReadOptions, FieldList, JsonReadOptions, JsonValue, NullValue, PartialMessage, PlainMessage } from "@bufbuild/protobuf";
import { Message, proto3 } from "@bufbuild/protobuf";

/**
 * Represents a CEL value.
 *
 * This is similar to `google.protobuf.Value`, but can represent CEL's full
 * range of values.
 *
 * @generated from message google.api.expr.v1alpha1.Value
 */
export declare class Value extends Message<Value> {
  /**
   * Required. The valid kinds of values.
   *
   * @generated from oneof google.api.expr.v1alpha1.Value.kind
   */
  kind: {
    /**
     * Null value.
     *
     * @generated from field: google.protobuf.NullValue null_value = 1;
     */
    value: NullValue;
    case: "nullValue";
  } | {
    /**
     * Boolean value.
     *
     * @generated from field: bool bool_value = 2;
     */
    value: boolean;
    case: "boolValue";
  } | {
    /**
     * Signed integer value.
     *
     * @generated from field: int64 int64_value = 3;
     */
    value: bigint;
    case: "int64Value";
  } | {
    /**
     * Unsigned integer value.
     *
     * @generated from field: uint64 uint64_value = 4;
     */
    value: bigint;
    case: "uint64Value";
  } | {
    /**
     * Floating point value.
     *
     * @generated from field: double double_value = 5;
     */
    value: number;
    case: "doubleValue";
  } | {
    /**
     * UTF-8 string value.
     *
     * @generated from field: string string_value = 6;
     */
    value: string;
    case: "stringValue";
  } | {
    /**
     * Byte string value.
     *
     * @generated from field: bytes bytes_value = 7;
     */
    value: Uint8Array;
    case: "bytesValue";
  } | {
    /**
     * An enum value.
     *
     * @generated from field: google.api.expr.v1alpha1.EnumValue enum_value = 9;
     */
    value: EnumValue;
    case: "enumValue";
  } | {
    /**
     * The proto message backing an object value.
     *
     * @generated from field: google.protobuf.Any object_value = 10;
     */
    value: Any;
    case: "objectValue";
  } | {
    /**
     * Map value.
     *
     * @generated from field: google.api.expr.v1alpha1.MapValue map_value = 11;
     */
    value: MapValue;
    case: "mapValue";
  } | {
    /**
     * List value.
     *
     * @generated from field: google.api.expr.v1alpha1.ListValue list_value = 12;
     */
    value: ListValue;
    case: "listValue";
  } | {
    /**
     * Type value.
     *
     * @generated from field: string type_value = 15;
     */
    value: string;
    case: "typeValue";
  } | { case: undefined; value?: undefined };

  constructor(data?: PartialMessage<Value>);

  static readonly runtime: typeof proto3;
  static readonly typeName = "google.api.expr.v1alpha1.Value";
  static readonly fields: FieldList;

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): Value;

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): Value;

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): Value;

  static equals(a: Value | PlainMessage<Value> | undefined, b: Value | PlainMessage<Value> | undefined): boolean;
}

/**
 * An enum value.
 *
 * @generated from message google.api.expr.v1alpha1.EnumValue
 */
export declare class EnumValue extends Message<EnumValue> {
  /**
   * The fully qualified name of the enum type.
   *
   * @generated from field: string type = 1;
   */
  type: string;

  /**
   * The value of the enum.
   *
   * @generated from field: int32 value = 2;
   */
  value: number;

  constructor(data?: PartialMessage<EnumValue>);

  static readonly runtime: typeof proto3;
  static readonly typeName = "google.api.expr.v1alpha1.EnumValue";
  static readonly fields: FieldList;

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): EnumValue;

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): EnumValue;

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): EnumValue;

  static equals(a: EnumValue | PlainMessage<EnumValue> | undefined, b: EnumValue | PlainMessage<EnumValue> | undefined): boolean;
}

/**
 * A list.
 *
 * Wrapped in a message so 'not set' and empty can be differentiated, which is
 * required for use in a 'oneof'.
 *
 * @generated from message google.api.expr.v1alpha1.ListValue
 */
export declare class ListValue extends Message<ListValue> {
  /**
   * The ordered values in the list.
   *
   * @generated from field: repeated google.api.expr.v1alpha1.Value values = 1;
   */
  values: Value[];

  constructor(data?: PartialMessage<ListValue>);

  static readonly runtime: typeof proto3;
  static readonly typeName = "google.api.expr.v1alpha1.ListValue";
  static readonly fields: FieldList;

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ListValue;

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ListValue;

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ListValue;

  static equals(a: ListValue | PlainMessage<ListValue> | undefined, b: ListValue | PlainMessage<ListValue> | undefined): boolean;
}

/**
 * A map.
 *
 * Wrapped in a message so 'not set' and empty can be differentiated, which is
 * required for use in a 'oneof'.
 *
 * @generated from message google.api.expr.v1alpha1.MapValue
 */
export declare class MapValue extends Message<MapValue> {
  /**
   * The set of map entries.
   *
   * CEL has fewer restrictions on keys, so a protobuf map represenation
   * cannot be used.
   *
   * @generated from field: repeated google.api.expr.v1alpha1.MapValue.Entry entries = 1;
   */
  entries: MapValue_Entry[];

  constructor(data?: PartialMessage<MapValue>);

  static readonly runtime: typeof proto3;
  static readonly typeName = "google.api.expr.v1alpha1.MapValue";
  static readonly fields: FieldList;

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): MapValue;

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): MapValue;

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): MapValue;

  static equals(a: MapValue | PlainMessage<MapValue> | undefined, b: MapValue | PlainMessage<MapValue> | undefined): boolean;
}

/**
 * An entry in the map.
 *
 * @generated from message google.api.expr.v1alpha1.MapValue.Entry
 */
export declare class MapValue_Entry extends Message<MapValue_Entry> {
  /**
   * The key.
   *
   * Must be unique with in the map.
   * Currently only boolean, int, uint, and string values can be keys.
   *
   * @generated from field: google.api.expr.v1alpha1.Value key = 1;
   */
  key?: Value;

  /**
   * The value.
   *
   * @generated from field: google.api.expr.v1alpha1.Value value = 2;
   */
  value?: Value;

  constructor(data?: PartialMessage<MapValue_Entry>);

  static readonly runtime: typeof proto3;
  static readonly typeName = "google.api.expr.v1alpha1.MapValue.Entry";
  static readonly fields: FieldList;

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): MapValue_Entry;

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): MapValue_Entry;

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): MapValue_Entry;

  static equals(a: MapValue_Entry | PlainMessage<MapValue_Entry> | undefined, b: MapValue_Entry | PlainMessage<MapValue_Entry> | undefined): boolean;
}

